package com.totopia.server.modules.dashboard.entity;

import com.totopia.server.commons.data.entity.UserDateAuditEntity;
import lombok.experimental.SuperBuilder;

import javax.persistence.*;

@Entity
@Table(name = "dashboard")
@SuperBuilder
public class DashboardEntity extends UserDateAuditEntity {
  private static final long serialVersionUID = 8891163223262220481L;

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Integer id;

  @Basic
  @Column(name = "title", nullable = false, length = 150)
  private String title;

  @Basic
  @Column(name = "description", nullable = true, length = 500)
  private String description;

  @Basic
  @Column(name = "url", nullable = false, length = 250)
  private String url;

  @Basic
  @Column(name = "sort_order", nullable = false)
  private Integer sortOrder;

  @Basic
  @Column(name = "display", nullable = false)
  private Boolean display = true;

    public DashboardEntity(Integer id, String title, String description, String url, Integer sortOrder, Boolean display) {
        this.id = id;
        this.title = title;
        this.description = description;
        this.url = url;
        this.sortOrder = sortOrder;
        this.display = display;
    }

    public DashboardEntity() {
    }

    public Integer getId() {
        return this.id;
    }

    public String getTitle() {
        return this.title;
    }

    public String getDescription() {
        return this.description;
    }

    public String getUrl() {
        return this.url;
    }

    public Integer getSortOrder() {
        return this.sortOrder;
    }

    public Boolean getDisplay() {
        return this.display;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public void setSortOrder(Integer sortOrder) {
        this.sortOrder = sortOrder;
    }

    public void setDisplay(Boolean display) {
        this.display = display;
    }

    public String toString() {
        return "DashboardEntity(id=" + this.getId() + ", title=" + this.getTitle() + ", description=" + this.getDescription() + ", url=" + this.getUrl() + ", sortOrder=" + this.getSortOrder() + ", display=" + this.getDisplay() + ")";
    }

    public boolean equals(final Object o) {
        if (o == this) return true;
        if (!(o instanceof DashboardEntity)) return false;
        final DashboardEntity other = (DashboardEntity) o;
        if (!other.canEqual((Object) this)) return false;
        final Object this$id = this.getId();
        final Object other$id = other.getId();
        if (this$id == null ? other$id != null : !this$id.equals(other$id)) return false;
        final Object this$title = this.getTitle();
        final Object other$title = other.getTitle();
        if (this$title == null ? other$title != null : !this$title.equals(other$title)) return false;
        final Object this$description = this.getDescription();
        final Object other$description = other.getDescription();
        if (this$description == null ? other$description != null : !this$description.equals(other$description))
            return false;
        final Object this$url = this.getUrl();
        final Object other$url = other.getUrl();
        if (this$url == null ? other$url != null : !this$url.equals(other$url)) return false;
        final Object this$sortOrder = this.getSortOrder();
        final Object other$sortOrder = other.getSortOrder();
        if (this$sortOrder == null ? other$sortOrder != null : !this$sortOrder.equals(other$sortOrder)) return false;
        final Object this$display = this.getDisplay();
        final Object other$display = other.getDisplay();
        if (this$display == null ? other$display != null : !this$display.equals(other$display)) return false;
        return true;
    }

    protected boolean canEqual(final Object other) {
        return other instanceof DashboardEntity;
    }

    public int hashCode() {
        final int PRIME = 59;
        int result = 1;
        final Object $id = this.getId();
        result = result * PRIME + ($id == null ? 43 : $id.hashCode());
        final Object $title = this.getTitle();
        result = result * PRIME + ($title == null ? 43 : $title.hashCode());
        final Object $description = this.getDescription();
        result = result * PRIME + ($description == null ? 43 : $description.hashCode());
        final Object $url = this.getUrl();
        result = result * PRIME + ($url == null ? 43 : $url.hashCode());
        final Object $sortOrder = this.getSortOrder();
        result = result * PRIME + ($sortOrder == null ? 43 : $sortOrder.hashCode());
        final Object $display = this.getDisplay();
        result = result * PRIME + ($display == null ? 43 : $display.hashCode());
        return result;
    }
}
